unit gNfrConnections;

// simply show me a bit about who i'm connected to.

(****************************************************************
Copyright (C)2000, Michael Ax. Created 2000. All rights reserved.
License to copy, use also for making and using derivative works
of this software is granted provided that that such works are
identified as "derived from the GnutViewer project" in all material
mentioning or referencing the derived work. Michael Ax makes no
representations concerning either the merchantability of this software
or the suitability of this software for any particular purpose. It is
provided "as is" without express or implied warranty of any kind.
These notices must be retained in this documentation and/or software.
*****************************************************************)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  gNutella, gNutFrame, StdCtrls, ExtCtrls;

type
  TgNutConnections = class(TGnutellaCustomFrame)
    ListBox1: TListBox;
    Panel1: TPanel;
    Button5: TButton;
    Edit3: TEdit;
    edCCount: TEdit;
    procedure Button5Click(Sender: TObject);
    procedure edCCountExit(Sender: TObject);
  private
    { Private declarations }
    iCCount: Integer;
    procedure ClientCreated(const CInfo: client_info_rec);
    procedure ClientConnected(const CInfo: client_info_rec);
    procedure ClientDisconnect(const CInfo: client_info_rec);
    procedure ClientProtocolConnect(const CInfo: client_info_rec);
  public
    { Public declarations }
    Servers: TStrings;
    procedure Init(aGnuTella: TGnuTellaTrans); override;
    end;

var
  gNutConnections: TgNutConnections;

implementation

{$R *.DFM}

procedure TgNutConnections.Init(aGnuTella: TGnuTellaTrans);
begin
  inherited Init(aGnuTella);
  with gNutella do begin
    OnClientCreated:= ClientCreated;
    OnClientConnected:= ClientConnected;
    OnClientDisconnect:= ClientDisconnect;
    OnClientProtocolConnect:= ClientProtocolConnect;
    end;
  edCCountExit(nil);
end;


procedure TgNutConnections.ClientCreated(const CInfo: client_info_rec);
begin
//  Entering('ClientCreated',cinfo.host);
  with listbox1.items do
    add(cinfo.host);
end;

procedure TgNutConnections.ClientConnected(const CInfo: client_info_rec);
begin
  gNutella.Log('ClientConnected~'+cinfo.host);
end;

procedure TgNutConnections.ClientDisconnect(const CInfo: client_info_rec);
var
  i:integer;
begin
//  Entering('ClientDisconnect',cinfo.host);
  with listbox1.items do begin
    i:=indexof(cinfo.host);
    if i>-1 then
      delete(i);
    end;
end;

procedure TgNutConnections.ClientProtocolConnect(const CInfo: client_info_rec);
begin
  gNutella.Log('ClientProtocolConnect~'+cinfo.host);
end;

procedure TgNutConnections.Button5Click(Sender: TObject);
var
  i:integer;
begin
  inherited;
  if not fileexists(edit3.text) then
    if pos(':',edit3.text)>0 then
      with GnuTella do
        ConnectNewHost(edit3.text) //connect directly
    else
  else
    with tstringlist.create do try
      loadfromfile(edit3.text);
      with GnuTella do
        for i:=0 to pred(count) do
          if i>=iCCount then break
          else ConnectNewHost(strings[i]);
    finally
      free;
      end;

end;

procedure TgNutConnections.edCCountExit(Sender: TObject);
begin
  inherited;
  with edCCount do begin
    iCCount:=strtointdef(Text,0);
    Text:= inttostr(iCCount);
    end;
end;

end.
